%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Mapping_Table = Coord_Directions_Mapping(Old_Coord_ID, New_Coord_ID)

global ErrCode;

global DB_COORD;
global AT_COORD;

global Coord_Z_Mapping_deg_tolerance;

Mapping_Table = [];

% Заполнение атрибутов старой СК
if (Old_Coord_ID == 0)
    Old_e_1 = [1;0;0];
    Old_e_2 = [0;1;0];
    Old_e_3 = [0;0;1];
else
    Old_e_1 = DB_COORD{AT_COORD(Old_Coord_ID)}.e_x;
    Old_e_2 = DB_COORD{AT_COORD(Old_Coord_ID)}.e_y;
    Old_e_3 = DB_COORD{AT_COORD(Old_Coord_ID)}.e_z;
end

% Заполнение атрибутов новой СК
if (New_Coord_ID == 0)
    New_e_3 = [0;0;1];
else
    New_e_3 = DB_COORD{AT_COORD(New_Coord_ID)}.e_z;
end

% Поиск направления старой СК, соответствующего направелнию Z новой СК
Success_flag = 0;

if (Success_flag == 0)
    
    Angle = acosd(dot(Old_e_1, New_e_3)); % Вектора имеют единичную длину

    if (Angle > 90)
        Angle = 180 - Angle;
    end

    if (Angle <= Coord_Z_Mapping_deg_tolerance)
        Success_flag = 1;
        Direction = 1;
    end

end

if (Success_flag == 0)
    
    Angle = acosd(dot(Old_e_2, New_e_3)); % Вектора имеют единичную длину

    if (Angle > 90)
        Angle = 180 - Angle;
    end

    if (Angle <= Coord_Z_Mapping_deg_tolerance)
        Success_flag = 1;
        Direction = 2;
    end
    
end

if (Success_flag == 0)
    
    Angle = acosd(dot(Old_e_3, New_e_3)); % Вектора имеют единичную длину

    if (Angle > 90)
        Angle = 180 - Angle;
    end

    if (Angle <= Coord_Z_Mapping_deg_tolerance)
        Success_flag = 1;
        Direction = 3;
    end
    
end

% Проверка флага
if (Success_flag == 0)
    fprintf (1, '\nОшибка функции Coord_Directions_Mapping: не удалось найти направление старой СК, соответствующее направелнию Z новой СК !\n');
    fprintf (1, 'Обратитесь к разработчику для решения этого вопроса.\n');
    ErrCode = -1;
    return;
end

% Заполнение таблицы мэппинга
switch Direction
    
    case 1
        Mapping_Table = [3;1;2;6;4;5];
    case 2
        Mapping_Table = [2;3;1;5;6;4];
    case 3
        Mapping_Table = [1;2;3;4;5;6];
    
end
